var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import classnames from 'classnames';
import { CollapseRowButton } from '../../CollapseRowButton';
import styles from './WithCollapseButton.module.css';
export var withCollapseButton = function (Component) {
    var WrappedComponent = function (componentProps) {
        var hasCollapseButton = componentProps.hasCollapseButton, restProps = __rest(componentProps, ["hasCollapseButton"]);
        return hasCollapseButton ? (React.createElement("div", { className: classnames(styles.cellWithCollapseLocal, 'cellWithCollapser') },
            React.createElement(CollapseRowButton, { className: styles.collapser, rowIndex: componentProps.rowIndex, rowValue: componentProps.rowValue }),
            React.createElement(Component, __assign({}, restProps)))) : (React.createElement(Component, __assign({}, restProps)));
    };
    WrappedComponent.displayName = "withCollapseButton(".concat(Component.displayName || 'Component', ")");
    return WrappedComponent;
};
